sbit R0 = P2^0;
sbit R1 = P2^1;
sbit R2 = P2^2;
sbit R3 = P2^3;

sbit C0 = P2^4;
sbit C1 = P2^5;
sbit C2 = P2^6;
sbit C3 = P2^7;

/*
{'1','2','3','A'},
	{'4','5','6','B'},
	{'7','8','9','C'},
	{'*','0','#','D'}
*/
code unsigned char keypad_lut[4][4] = {

	{'1','2','3','+'},
	{'4','5','6','-'},
	{'7','8','9','*'},
	{'R','0','=','/'}
};

bit colscan()
{
	return(C0 & C1 & C2 &C3);
}

unsigned char keyscan()
{
		unsigned char row,col;
	
		R0 = R1 = R2 = R3 = 0;
		C0 = C1 = C2 = C3 = 1;
		
		while(colscan()==1);
		
		R0 = 0;
		R1 = R2 = R3 = 1;
		
		if(colscan()==0)
		{
				row = 0;
				goto colcheck;
		}
		
		R1 = 0;
		R0 = R2 = R3 = 1;
	
		if(colscan()==0)
		{
				row = 1;
				goto colcheck;
		}
		
		
		R2 = 0;
		R1 = R0 = R3 = 1;
		
		if(colscan()==0)
		{
				row = 2;
				goto colcheck;
		}
		
		R3 = 0;
		R0 = R1 = R2 = 1;
		
		if(colscan()==0)
		{
				row = 3;
				goto colcheck;
		}
		colcheck:
		
		if(C0==0)
			col = 0;
		else if(C1==0)
			col = 1;
		else if(C2==0)
			col = 2;
		else if(C3==0)
			col = 3;
		
		delay_ms(100);
		while(colscan()==0);
	
		return (keypad_lut[row][col]);
}